<?php
/* 	
	almawiki | © alain marty | http://marty.alain.free.fr  
 	initialement basé sur le code de :
 	rowiki | © marc rohlfing | http://www.rowlff.de/
 	version : la date de la dernière version est indiquée dans FOOT_PAGE, ci-dessous.
*/
/*
	Mod WikiTeP © KEOPS (E.Ostenne) 08/2006 http://emmanuel.ostenne.free.fr
	pour TracenPoche http://www.tracenpoche.net 
*/
	
include( "_perso_.php");
// KEOPS : wikitep <tep>...</tep>
include( "wikitep.php");
//	définition des chaines constantes, version française
define( "FOOT_PAGE", "moteur : almawiki v.20060823" );	// valeur changée à chaque mise à jour
define( "HOME",  "accueil" );	// attention, changer la définition de ces trois constantes
define( "ADMIN", "admin" );		// conduit à la création de trois nouvelles pages dans lesquelles
define( "HELP",  "aide" );		// il conviendra de transposer les contenus des pages accueil, admin et aide

define( "EDIT", "&eacute;diter..." );
define( "EDIT_BADPASS", "Erreur sur le mot de passe" );
define( "LOCKED_PAGE", "-" );
define( "LAST_CHANGE", "page modifi&eacute;e le " );
define( "CANCEL_BUTTON", "annuler" );
define( "VISU_BUTTON", "visualiser" );
define( "DONE_BUTTON", "valider" );
define( "DEFAULT_CONTENT", "page vide !" );
define( "PAGES_DIR", "wikiteppages/" );
define( "BACKUP_DIR", "wikitephistory/");
define( "DATA_DIR", "wikitepdata/" );
define( "TIME_FORMAT", "%d/%m/%y %R");

define( "SEARCH_BUTTON", "rechercher ..." );
define( "SEARCH", "recherche" );
define( "SHOW", "affiche" );
define( "SEARCH_NOTHING", "Et si vous entriez quelque chose !" );

define( "RECENTS_PAGES", "pages r&eacute;centes" );
define( "RECENTS_TITRE", "les 20 derni&egrave;res pages modifi&eacute;es :" );
define( "RECENTS_NOACCESS", "Il faut d&eacute;verrouiller le site pour consulter les pages r&eacute;centes." );
define( "HISTORY", "historique" );
define( "HISTORY_TITRE", "historique de la page : " );
define( "HISTORY_NB", "Nombre de sauvegardes : " );

define( "LOAD", "t&eacute;l&eacute;chargement" );
define( "LOAD_BUTTON", "Télécharger le fichier" );
define( "LOAD_NOACCESS", "Il faut d&eacute;verrouiller le site pour pouvoir t&eacute;l&eacute;charger." );
define( "LOAD_ERR_1", "D&eacute;sol&eacute; la taille du fichier dépasse la taille autoris&eacute;e." );
define( "LOAD_ERR_2", "D&eacute;sol&eacute; le type du fichier n'est pas dans la liste des types autoris&eacute;s" );
define( "LOAD_ERR_3", "Erreur de transfert dans le dossier de t&eacute;l&eacute;chargement. Recommencez !" ); 
define( "LOAD_ERR_4", "D&eacute;sol&eacute; l'extension du fichier n'est pas dans la liste des extensions autoris&eacute;es" );//KEOPS
define( "LOAD_ERR_5", "D&eacute;sol&eacute; PHP ne peut pas faire partie du nom du fichier !" );//KEOPS
define( "LOAD_OK", "OK ! Le fichier a bien &eacute;t&eacute; t&eacute;l&eacute;charg&eacute; dans le dossier data sous le nom : " );
define( "LOAD_DESCRIPTION", "Il est possible de t&eacute;l&eacute;charger des fichiers de type "
								."txt, jp(e)g, gif, png, pdf, openoffice 1 & 2 (hors modèle) de taille inf&eacute;rieure &agrave; " ); //KEOPS

define( "LOCK_FILE", "meca/lock.txt" );
define( "LOCK", "verrouillage" );
define( "LOCK_BUTTON", "verrouiller/deverrouiller" );
define( "LOCK_NOREAD", "Le fichier n'est pas lisible !" );
define( "LOCK_READONLY", "Le fichier est en mode lecture seule !" );
define( "LOCK_BADLOGPASS", "Mauvais login et mot de passe !" );
define( "LOCK_LOCKED", "Le site est verrouill&eacute; globalement !" );
define( "LOCK_UNLOCKED", "Le site est deverrouill&eacute; globalement !" );
define( "LOCK_INIT", "La valeur &agrave; modifier doit &ecirc;tre true ou false !" );

//KEOPS PASS
define ( "PASS_COOKIE", "Le cookie actuellement pr&eacute;sent n'est pas correct. Il a &eacute;t&eacute; r&eacute;voqu&eacute;.");
define ( "PASS_PROMPT", "Vous avez saisi un mauvais mot de passe !");
define ( "PASS_SECURITY", "La modification n'a pas &eacute;t&eacute; enregistr&eacute;e par s&eacute;curit&eacute; pour le site.");
define ( "PASS_RETRY", "Recommencer");

define( "THEMES_DIR", "themes/" );;
define( "THEMES_FILE", "theme.txt" );
define( "THEMES", "th&egrave;mes" );
define( "THEMES_BUTTON", "appliquer le th&egrave;me" );
define( "THEMES_NB", " th&egrave;mes" );
define( "THEMES_NOACCESS", "Il faut d&eacute;verrouiller le site pour modifier les th&egrave;mes." );

//	utilities :

function microtime_float()
{	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
}

function security( $chaine )
{
	// 1) traitement des slashes et des espaces avant et après :
	$chaine = trim( stripslashes( $chaine ) );
	// 2) blocage des balises script
	$chaine = preg_replace("/(<script *)(.+)(<\/script>)/Uis", 'noscript please', $chaine );
	// 3) blocage des balises form
	$chaine = preg_replace("/(<form *)(.+)(<\/form>)/Uis", 'noform please', $chaine );
	// 4) blocage des balises embed, applet, object : non prévu pour l'instant.
	
	//faille PHP relevée le 18/11/2006 par laurent egs
	$chaine = preg_replace("/(<\?php)/Uis", '<noPHP', $chaine ); //  
	
	return $chaine;
}


function str_split_php4($text, $split = 1)
{
    if (!is_string($text)) return false;
    if (!is_numeric($split) && $split < 1) return false;
    $len = strlen($text);
    $array = array();
    $i = 0;
     while ($i < $len) {
        $key = NULL; 
        for ($j = 0; $j < $split; $j += 1) {
            $key .= $text{$i};           
            $i += 1;   
        }       
        $array[] = $key;
    }
    return $array;
}

//KEOPS PASS
function cryptage( $chaine) {
	/*$pass = str_split_php4($chaine);
	foreach ($pass as $hashpass) {
		$majorsalt .= md5($hashpass);
	}
	$corehash = md5($majorsalt);
	return $corehash;*/
	return md5($chaine);
}

function wikisyntax( &$chaine, $pagename )
{	// à améliorer ...
/*
	on a constaté que certains robots effacent le contenu des pages pour le remplacer 
	par des listes d'adresses vers des sites divers afin d'augmenter leur PageRank (Google)
 	on peut signaler l'effacement complet du contenu  et bloquer l'affichage de ces listes d'adresses
 	en insérant systématiquement en tête des pages une expression du genre %antipiratage%, et en exécutant ce test :
		if (!eregi( '%antipiratage%', $chaine )) { $chaine = '<h1>piratage</h1>'; return; }
	et en remplaçant le traitement 6) :
		$chaine = preg_replace( '/%(..vert|antipiratage)%/','<span style="display:none;">$1</span>', $chaine );
*/
	// 1) traitement des liens internes : [[lien]] -> <a href="index.php?page=lien">lien</a>
	preg_match_all("/\[\[([0-9a-zA-Zéèêàâçù .:#'_-]+)\]\]/U", $chaine, $matches, PREG_PATTERN_ORDER);

	foreach ($matches[1] as $match)		// affichage différencié des pages existantes ou non
		if (file_exists(PAGES_DIR.$match.'.txt'))
			$chaine = str_replace("[[$match]]", "<a href=\"index.php?page=$match\">$match</a>", $chaine);
		else
			$chaine = str_replace("[[$match]]", "<a class=\"pending\" href=\"index.php?page=$match\">$match</a>", $chaine);	

	// 2) traitement des liens absolus : [pixar|http://www.pixar.com] -> <a href="http://www.pixar.com">pixar</a>
	$chaine = preg_replace("/\[\[([0-9a-zA-Zéèêàùâç .:#'_-]+)\|([0-9a-zA-Zéèêàùâç .:\/?=#'_-]+)\]\]/U", '<a href="$2">$1</a>', $chaine);
	/*
	//http:// présent
	$chaine = preg_replace("/\[\[([0-9a-zA-Zéèêàùâç .:#'_-]+)\|http:\/\/([0-9a-zA-Zéèêàùâç .:\/?=#'_-]+)\]\]/U", '<a href="http://$2">$1</a>', $chaine);
	//sinon interne (pas de ?page= précédent !)
	$nres=preg_match_all("/\[\[([0-9a-zA-Zéèêàùâç .:#'_-]+)\|(.+)\]\]/U", $chaine, $match, PREG_PATTERN_ORDER);
	echo $nres."**\n";
 	for($i=0; $i<$nres; $i++)	{	// affichage différencié des pages existantes ou non
		echo $match[0][$i]." -> ".$i."*\n";
		echo $match[1][$i]."*\n";
		echo $match[2][$i]."*\n";
		if(preg_match($match[2][$i], "@^[\?|data]@U")==0) {
			if (file_exists(PAGES_DIR.$match[2][$i].'.txt'))
				$chaine = str_replace($match[0][$i], "<a href=\"index.php?page=".$match[2][$i]."\">".$match[1][$i]."</a>", $chaine);
			else
				$chaine = str_replace($matches[0][$i], "<a class=\"pending\" href=\"index.php?page=".$match[2][$i]."\">".$match[1][$i]."</a>", $chaine);	
		} else $chaine = str_replace($matches[0][$i], "<a href=\"".$match[2][$i]."\">".$match[1][$i]."</a>", $chaine);
	}
	*/
	// 3) traitement des adresses mail : marty.alain@free.fr -> <a href="mailto:marty.alain@free.fr">marty.alain@free.fr</a>
	$chaine = preg_replace("/\[\[([0-9a-z._-]+@[0-9a-z._-]+.[a-z]{2})\]\]/U", '<a href="mailto:$1">$1</a>', $chaine);

	// 4) traitement des images : {URL_image|hauteur|infobulle} -> <img src="URL_image" height="hauteur" title="infobulle" />
	$chaine = preg_replace("/\{([0-9a-zA-Z .()\/_-]+\.(jpg|gif|png))\|([0-9+-]+)\|([0-9a-zA-Zéèêàùâç .:#'()_-]+)\}/U", '<img src="$1" height="$3" title="$4" alt="$4" />', $chaine);


	// 5) traitement des groupes d'images (faisant appel à un script) : 
	// {{test|[ [image_1.jpg],.., [image_n.jpg] ]|100 -> <script>test=[ [image_1.jpg],.., [image_n.jpg] ];
	// afficher_images("test", test, "100")<fin script>
	$chaine = preg_replace( "/\{\{([0-9a-zA-Z_]+?)\|(.+?)\|([-0-9]+?)\}\}/is","<script type=\"text/javascript\">$1=$2; afficher_images(\"$1\",$1,\"$3\");</script>", $chaine );

	// 6) traitement des marquages %ouvert% et %invert%
	$chaine = preg_replace( "/%(..vert)%/",'<span style="display:none;">$1</span>', $chaine );
	
	// 6bis) KEOPS <tep> <cep> : voir include
	$chaine = affiche_tep($chaine, DATA_DIR); // <tep>...</tep>
	$chaine = affiche_cep($chaine, DATA_DIR); // <cep>...</cep>
	$chaine = affiche_tepscript($chaine, $pagename, DATA_DIR); // <tepscript>...</tepscript>
	$chaine = affiche_cepscript($chaine, $pagename, DATA_DIR); // <cepscript>...</cepscript>
	
	// 7) affichage de code HTML	
	preg_match_all('/%%(.+?)%%/is', $chaine, $matches, PREG_PATTERN_ORDER);
	foreach ($matches[1] as $match)
		$chaine = str_replace("%%$match%%", htmlentities($match), $chaine);
	
}

// classe wiki

class mywiki
{	var $home, $admin, $help, $edit, 	// menu : home | admin | help | edit
		$page, $content, $time, 	// la matière première
		$search, $editing;			// KEOPS additif editing pour le titre de la page édition

	function mywiki()					// constructeur appelé à l'instantiation
	{	// 1) les entrées :
		$this->editing=false;
		$toSave 	= isset($_POST['content']);									// on arrive de l éditeur
		$toEdit 	= isset( $_GET['action']) && $_GET['action'] == 'edit';		// on appelle l éditeur
		$history 	= isset( $_GET['action']) && $_GET['action'] == 'history';	// on appelle l historique d une page
		$recents 	= isset( $_GET['action']) && $_GET['action'] == 'recents';	// on appelle les pages récentes  
		$lock 		= isset( $_GET['action']) && $_GET['action'] == 'lock';		// on appelle le verrouillage
		$load 		= isset( $_GET['action']) && $_GET['action'] == 'load';		// on appelle le téléchargement
		$search 	= isset( $_GET['action']) && $_GET['action'] == 'search';	// on appelle le champ recherche
		$show 		= isset( $_GET['action']) && $_GET['action'] == 'show';		// on appelle le champ recherche
		$theme 		= isset( $_GET['action']) && $_GET['action'] == 'theme';	// on appelle le champ theme
		// construction du titre de la page et de son contenu :
		if ($toSave)															// pour valider le content de l éditeur
		{	$this->page = security($_POST['page']);								// on récupère le nom filtré de la page
			if ($this->is_editable())											// si la page est vraiment éditable
			{	$this->content = security($_POST['content']);					// on récupère le content filtré de la page
				//KEOPS PASS
				if( $this->write($_POST['mdp']) )	{						// on l enregistre dans un fichier texte
					header("location: index.php?page=".urlencode($this->page));	// et on appelle la page éditée
				}
			}
			else																// sinon
				header("location: index.php?page=".HOME);						// on renvoie sur la page accueil
		}
		elseif ($history) {	$this->page = HISTORY; 		$this->history( security($_GET['page']) ); }
		elseif ($recents) 
		{	$this->page = RECENTS_PAGES;
			if ($this->is_editable())	$this->recents();
			else						$this->content = '<h6>'.RECENTS_NOACCESS.'</h6>';
		}
		elseif ($theme) 
		{	$this->page = THEMES;
			if ($this->is_editable())	$this->theme();
			else						$this->content = '<h6>'.THEMES_NOACCESS.'</h6>';
		}
		elseif ($load) 
		{	$this->page = LOAD; 		
			if ($this->is_editable())	$this->load();
			else						$this->content = '<h6>'.LOAD_NOACCESS.'</h6>';
		}
		elseif ($search) {	$this->page = SEARCH; 		$this->search(); }
		elseif ($show) {						 		$this->show( security($_GET['page']), security($_GET['q']) ); }
		elseif ($lock) {	$this->page = LOCK; 		$this->lock(); }
		else																// quand on vient d'un lien index.php?page=xxx								
		{	$this->page = (isset( $_GET['page'])) ? security($_GET['page']) : HOME;	// on récupère le nom filtré, sinon HOME
			if (file_exists(PAGES_DIR.$this->page.'.txt'))					// si la page existe
			{	$this->content = $this->read(PAGES_DIR.$this->page.'.txt');	// on récupère le content depuis le fichier texte
				if ($toEdit)												// quand on vient d'un lien index.php?page=xxx&action=edit
					$this->edit(true);											// le content est présenté dans l'éditeur
			}
			else															// si la page n'existe pas
			{	$this->content = DEFAULT_CONTENT;							// on définit le content à sa valeur par défaut
				$this->edit(true);												// et on invite à l'édition
			}
		}
		if (!$toEdit && !$show)	wikisyntax( $this->content, $this->page ); // quand on n'appelle pas l'éditeur ou show on applique au content la syntaxe wiki
		// gestion du menu :
		$this->home = ($this->page != HOME)? '<a href="index.php?page='.HOME.'">'.HOME.'</a>' : HOME;
		$this->admin = ($this->page != ADMIN)? '<a href="index.php?page='.ADMIN.'">'.ADMIN.'</a>' : ADMIN;
		$this->search = ($this->page != SEARCH)? '<a href="index.php?action=search">'.SEARCH.'</a>' : SEARCH; //KEOPS
		$this->help = ($this->page != HELP)? '<a href="index.php?page='.HELP.'">'.HELP.'</a>' : HELP;
		$this->edit = (!$this->is_editable() || $toEdit || $recents || $history || $lock || $load || $search || $theme) ? 
								LOCKED_PAGE : '<a href="index.php?page='.$this->page.'&amp;action=edit">'.EDIT.'</a>';
		$this->time = ($recents || $history || $lock || $load || $search || $theme) ?
								'-' : LAST_CHANGE . strftime(TIME_FORMAT, @filemtime(PAGES_DIR.$this->page . '.txt'));
	}
			
	function edit( $bool_titre )	
	{	// KEOPS titre page édition
		$this->editing=($bool_titre==true);
		// KEOPS carspé
		$temp = $this->content;
		$temp = preg_replace("/\&([0-9a-zA-Z#]+)\;/", "~$1~", $temp );
		//
		$this->content = '<form id="editeur" method="post" action="" onsubmit="return controler();" >'
		.'<input type="hidden" name="action" value="edit" />'				// edit sera dans $_POST['action']
		.'<input type="hidden" name="mdp" value="" />'				// KEOPS PASS : le mot de passe sera mis dans $_POST['mdp'] 
		.'<input type="hidden" name="page" value="'.$this->page.'" />'		// page sera dans $_POST['page']
		.ajoute_menubar_tep() // KEOPS menu boutons
		.'<textarea name="content" cols="80" rows="30">'.$temp.'</textarea><br />'		// content sera dans $_POST['content']
		."Les caract&egrave;res sp&eacute;ciaux &amp;...; sont remplac&eacute;s par ~...~ mais demeurent utilisables.<br />" // KEOPS carspé
		.'<input type="button" value="'.CANCEL_BUTTON.'" accesskey="p" onclick="javascript:history.back()" />'
		.'<input type="button" value="'.VISU_BUTTON.'" accesskey="v" onclick="javascript:visualiser()" />'
		.'<input type="submit" value="'.DONE_BUTTON.'" accesskey="s" /></form>';
	}
	
	function read( $filename )
	{
		if (!$file = @fopen($filename, 'r'))
			die('Pas pu ouvrir la page '.$filename);
		$temp = @fread($file, @filesize($filename));
		@fclose($file);
		return $temp;
	}
	
	// KEOPS PASS
	function write( $mdp ) {
		//on vérfie le mot de passe	renvoyé par Javascript
		if($mdp == "cookie") {
			if($_COOKIE['chevalTeP']<>cryptage(PAGESPASS)) {
				$this->mauvais_motdepasse("cookie");
				return false;
			} else {
				setcookie('chevalTeP',cryptage(PAGESPASS),time()+24*3600);
			}
		} else {
			if(cryptage($mdp)!=cryptage(PAGESPASS)) {
				$this->mauvais_motdepasse("prompt");
				return false;
			} else {
				setcookie('chevalTeP',cryptage(PAGESPASS),time()+24*3600);
			}
		}
		//
		$temp = $this->page;
		//pirates sur Diagonales -> on prévient le chef !
		if( $temp == 'Diagonales') {
			//keops
			$toaa="emmanuel";
			$tobb="ostenne";
			mail($toaa.".".$tobb."@free.fr","[WikiTeP]modifs non faites",$this->page."\nhttp://tracenpoche.free.fr/index.php?page=".$this->page."\n".$_SERVER['REMOTE_ADDR']."\npas fait !");
			return false;
		}
		//
		// KEOPS carspé
		$temp = $this->content;
		$temp = preg_replace("/\~([0-9a-zA-Z#]+)\~/", "&$1;", $temp );	
		//
		sauve_scripts($temp, $this->page, DATA_DIR);
		//
		$mypage = PAGES_DIR.$this->page.'.txt';
		if (!$file = @fopen($mypage, 'w'))
			die('Could not write page!');
		@fputs($file, $temp); // KEOPS carspé
		@fclose($file);
		// sauvegarde dans l'historique :
		if (BACKUP_DIR <> '') 
		{	$complete_dir_s = BACKUP_DIR.$this->page."/";
			if (! $dir = @opendir($complete_dir_s))
				mkdir($complete_dir_s);
			if (! $file = @fopen($complete_dir_s . date("Ymd-His", mktime(date("H"))) . ".bak", "a"))
				die("Could not write backup of page!");
		 	@fputs($file, date("Y/m/d H:i:s", mktime(date("H"))) . " | " . " (" . $_SERVER['REMOTE_ADDR'] . ")\n\n");
			@fputs($file, $temp); // KEOPS carspé
			@fclose($file);
		}
		//keops : petite info en temps réel sur la page modifiée
		$toaa="emmanuel";
		$tobb="ostenne";
		//mail($toaa.".".$tobb."@free.fr","[WikiTeP]modifs",$this->page."\nhttp://tracenpoche.free.fr/index.php?page=".$this->page."\n".$_SERVER['REMOTE_ADDR']);
		return true;
	}

	//KEOPS PASS
	function mauvais_motdepasse($mode) {
		$chaine = "<h4><font color='red'>".EDIT_BADPASS."</font></h4>\n<p>&nbsp;</p>\n"; // KEOPS : le .= remplacé par =
		if($mode="cookie") {
			$chaine .= "<p>".PASS_COOKIE;
			setcookie('chevalTeP',"",time()-3600);
		} else {
			$chaine .= "<p>".PASS_PROMPT;
		}
		$chaine .= "<br><font color='red'>".PASS_SECURITY."</font></p><p>&nbsp;</p>";
		$chaine .= "<a href='index.php?page=".$this->page."'>".PASS_RETRY."</a>"; // edit ?
		$this->content = $chaine;
	}

	function recents()									// placer les chaines dans des define() en vue d'internationalisation
	{	$dir = opendir(getcwd() . "/".PAGES_DIR);
		while ($file = readdir($dir))
			if (preg_match("/.txt/", $file))
				$filetime[$file] = filemtime(PAGES_DIR . $file);
		arsort($filetime);
		$chaine = '<h4>'.RECENTS_TITRE.'</h4>'; // KEOPS : le .= remplacé par =
		$chaine .= "<table border='0' cellspacing='0' cellpadding='2'>";
		$filetime = array_slice($filetime, 0, 20);
		foreach ($filetime as $filename => $timestamp) 
		{	$filename = substr($filename, 0, strlen($filename) - 4);
			$chaine .= "<tr><td><a href=\"index.php?page=$filename\">$filename</a></td><td>". strftime(TIME_FORMAT, $timestamp) 
					 . "</td><td><a href='index.php?page=".urlencode($filename)."&amp;action=history'>historique</a></td></tr>";
		}
		$chaine .= "</table>";
		$this->content = $chaine;
	}

	function history( $nom_page )
	{	$chaine = '';
		$nom_fichier = getcwd() . "/" . BACKUP_DIR . $nom_page . ".bak";	
		$repertoire  = getcwd() . "/" . BACKUP_DIR . $nom_page;
		if ( is_dir($repertoire)  && $dir = opendir($repertoire) )
		{	$chaine .= '<h4>'.HISTORY_TITRE.$nom_page.'</h4>';
			while ($file = readdir($dir))
				if (preg_match("/.bak/", $file))
				{	$myfile = BACKUP_DIR . $nom_page . "/" . $file; 
					$filetime[$file] = filemtime($myfile); 
				}
			closedir($dir);
			natsort($filetime);											
		// 	$filetime = array_slice($filetime, 0, 20);
			$N = count($filetime);
			$chaine .= '<p>'. HISTORY_NB . $N . '.</p><p>';
			$i=1;
			foreach ($filetime as $filename => $temp) 					// $temp est nécessaire, pourquoi ?
			{	$filename_short = substr($filename, 0, strlen($filename) - 4);
				$chaine .= '<a href="' . BACKUP_DIR . $nom_page . '/' . $filename . '">' . $filename_short . '</a> ||' . $i . '||<br />';
				$i++;
			}
			$chaine .='</p>';
		}
		else
			$chaine .= 'no backup';
		$this->content = $chaine;
	}

	function search()
	{	$this->content = "<form method='post' action=''>"
				."<input type='hidden' name='action' value='search' />"
				."<input type='text' name='search' value='' />"
				."<input type='submit' accesskey='s' value='".SEARCH_BUTTON."' />"
				."</form>";
		if (isset( $_POST['action']) && $_POST['action'] == 'search')
		{	$qqq = (!isset( $_POST['search'])) ?  '' : $_POST['search'];
			$qqq = ereg_replace('[^[:space:]a-zA-Z0-9_éèçàù.-]', '', $qqq);		// tout sauf nasty things ; traitement partiel des accents ...		
			if ($qqq)
			{	$dir = opendir(getcwd() . "/" . PAGES_DIR);
				$chaine ="<p>";
				while ($file = readdir($dir)) 
				{	if (preg_match("/.txt/", $file)) 
					{	$handle = fopen(PAGES_DIR . $file, "r");
						$temp = fread($handle, filesize(PAGES_DIR . $file));
						fclose($handle);
					//	if (preg_match("/$qqq/i", $temp) || preg_match("/$qqq/i", PAGES_DIR."/".$file)) 
						if (preg_match("/$qqq/i", $temp)) 												// modif du 23/08/2006
						{	$file = substr($file, 0, strlen($file) - 4);
							$chaine .= "<a href=\"index.php?page=$file&amp;action=show&amp;q=$qqq\">$file</a><br />";
						}
					}
				}
				$chaine .="</p>";
				$this->content .= $chaine;
			}
			else
				$this->content .= "<h6>".SEARCH_NOTHING."</h6>";
		}
	}

	function show( $page, $qqq )
	{	$this->page = $page;
		$this->content = $this->read(PAGES_DIR.$page.'.txt');
	//	wikisyntax( $this->content );
		$this->content = ereg_replace( $qqq, '<span style="background:#ff0; color:#00f">'.$qqq.'</span>', $this->content );
		wikisyntax( $this->content, $this->page );		// modif du 23/08/2006
	}
	
	function load()
	{	$this->content = '<h3>'.LOAD.'</h3><p>'.LOAD_DESCRIPTION.SIZE_MAX
				.' ko.<br> Voir la liste des <a href="'.DATA_DIR.'?type=texte">Scripts figures</a> '
				.'ou <a href="'.DATA_DIR.'?type=image">Fichiers images</a> '
				.'ou <a href="'.DATA_DIR.'?type=autre">Autres médias</a> '
				.'déjà chargés</p>'
				.'<form enctype="multipart/form-data" action="" method="post">'
				.'<input type="hidden" name="MAX_FILE_SIZE" value="'.(SIZE_MAX*1024).'" />'
				.'<input type="hidden" name="phase" value="traitement" />'
				.'<input name="le_fichier" type="file" size="40" maxlength="100" />'
				.'<input type="submit" accesskey="s" value="'.LOAD_BUTTON.'" />'
				.'</form><hr />';
		if( isset($_POST['phase']) && ('traitement' == $_POST['phase']) )
		{	// types valides : *.jpg ou *.jpeg, *.gif, *.png, *.pdf, *.wav, *.qt ou *.mov
			// *.txr *.sxw *.sxc *.sxd *.sxi *.sxm et *.odt *.ods *.odp *.odg *.odc *.odf *.odi, *.xml
			$types = array( "image/jpeg", "image/gif", "image/png", "application/pdf", "audio/x-wav", "video/quicktime", "text/plain", "application/vnd.sun.xml.writer", "application/sxw", " application/vnd.sun.xml.calc", "application/sxc", "application/vnd.sun.xml.draw", "application/sxd","application/vnd.sun.xml.impress", "application/sxi", "application/vnd.sun.xml.math", "application/sxm","application/vnd.oasis.opendocument.text", "application/vnd.oasis.opendocument.spreadsheet", "application/vnd.oasis.opendocument.presentation", "application/vnd.oasis.opendocument.graphics", "application/vnd.oasis.opendocument.chart", "application/vnd.oasis.opendocument.formula", "application/vnd.oasis.opendocument.image", "text/xml", "application/x-shockwave-flash");
			$extensions = array( "jpg", "jpeg", "gif", "png", "pdf", "wav", "mov", "qt", "txt", "sxw", "sxc", "sxd","sxi", "sxm","odt", "ods", "odp", "odg", "odc", "odf", "odi","xml","swf");
			$nom   	= $_FILES['le_fichier']['name'];
			$posext = strpos($nom, ".");
			if($posext===false) {
				$extension="(aucune extension)";
			} else {
				$extension=substr($nom, $posext+1);
			}
			//$type   = $_FILES['le_fichier']['type'];
			$taille	= $_FILES['le_fichier']['size'];
			$temp 	= $_FILES['le_fichier']['tmp_name'];
			$basenom = basename( $nom ); 
			//print_r("<p>".$nom." - ".$extension."</p>");
			$chaine = '';
			//elseif ( !in_array( $type, $types ) and (basename($nom,".txt")==$nom) )		$chaine = LOAD_ERR_2.": ".$type; // KEOPS
			if ($taille > SIZE_MAX * 1024)												$chaine = LOAD_ERR_1;
			elseif ( !in_array($extension, $extensions) )								$chaine = LOAD_ERR_4.": .$extension"; // KEOPS
			elseif ( eregi( "php", $basenom ) )											$chaine = LOAD_ERR_5; // KEOPS
			elseif( !move_uploaded_file($temp, DATA_DIR . $basenom))					$chaine = LOAD_ERR_3;
			else																		$chaine = LOAD_OK."<b>".$basenom."</b>";
			$this->content .= $chaine;
		}
	}		

	function lock()									// placer les chaines dans des define() en vue d'internationalisation
	{	$this->content = '<h3>'.LOCK.'</h3>'
				.'<form name="filtre" method="post" action="">'
				.'<input type="hidden" name="phase" value="traitement" />'
				.'<table style="width: 200pt;">'
				.'<tr><td align="right">Login&nbsp;:</td>'
				.'<td><input type="text" name="login" size="20" maxlength="10" /></td></tr>'
				.'<tr><td align="right">Mot&nbsp;de&nbsp;passe&nbsp;:</td>'
				.'<td><input type="password" name="passe" size="20" maxlength="10" /></td></tr><tr><td></td><td>'
				.'<input type="submit" accesskey="s" value="'.LOCK_BUTTON.'" onclick="location.href=\'index.php?action=lock\';" /></td></tr>'
				.'</table></form>';
		if( isset($_POST['phase']) && ('traitement' == $_POST['phase']) )
		{	$chaine = '';
			if (!$plock = @fopen(LOCK_FILE, "r"))
				$chaine = '<h6>'.LOCK_NOREAD.'</h6>';
			$lock = @fread($plock, 10);
			@fclose($plock);
			if (!(($_POST['login'] == LOGIN) && ($_POST['passe'] == PASS)))
				$chaine = '<h6>'.LOCK_BADLOGPASS.'</h6>';
			else
			{	if (!$plick = @fopen(LOCK_FILE, "w"))
					$chaine = '<h6>'.LOCK_READONLY.'</h6>';
				if ($lock=='false')
				{	fwrite( $plick, 'true' );
					@fclose( $plick );
					$chaine = '<h6>'.LOCK_LOCKED.'</h6>';
				}
				elseif ($lock=='true')
				{	fwrite( $plick, 'false' );
					@fclose( $plick );
					$chaine = '<h6>'.LOCK_UNLOCKED.'</h6>';
				}
				else
				{	@fwrite( $plick, 'false' );	// on réinitialise le fichier meca/lock.txt
					@fclose( $plick );	
					$chaine = '<h6>'.LOCK_INIT.'</h6>';
				}
			}
			$this->content .= $chaine;
		}
	}

	function is_editable()
	{	// return false;
		$plock = @fopen(LOCK_FILE, "r");
		$lock = @fread($plock, 5);
		@fclose($plock);
		$ouvert = "%ouvert%";
		$invert = "%invert%";
		$file = @fopen(PAGES_DIR . $this->page . ".txt", "r");
		$cont = @fread($file, 255);				// lit les 255 premiers caractères
		@fclose($file);
		if ($lock == 'false')					// deverrouillage global
			return !eregi($invert, $cont);		// éditable si marquée invert
		else									// verrouillage global
		{	if (eregi($ouvert, $cont ))			// page marquée ouvert
				return true;					// toujours éditable
			else								
				return eregi($invert, $cont );	// editable si marquée invert
		}
	}

	function theme()
	{	if( isset($_POST['phase']) && ('traitement' == $_POST['phase']) )
		{	$choix = security( $_POST['choix'] );
			if (!$ptheme = @fopen(THEMES_DIR.THEMES_FILE, "w"))
				die( 'probleme avec w' );
			$theme = @fwrite($ptheme, $choix);
			@fclose($ptheme);	
		}
		else
		{	if (!$ptheme = @fopen(THEMES_DIR.THEMES_FILE, "r"))
				die( 'probleme avec r' );
			$choix = @fread($ptheme, @filesize(THEMES_DIR.THEMES_FILE));
			@fclose($ptheme);
		}
		$nb = 0;
		if ( is_dir(THEMES_DIR)  && $themes_dir = @opendir(THEMES_DIR) )
		{	while ($dir = readdir($themes_dir) )
				if (is_dir(THEMES_DIR.$dir) && !eregi('\.', $dir) )
				{	$skin[$nb] = $dir;
					$nb++;
				}
			closedir($themes_dir);
		}
		$chaine = '<a href="index.php?page=accueil">accueil</a>';
		$chaine .= '<h2>'.$nb.THEMES_NB.'</h2>';
		$chaine .= '<form name="filtre" method="post" action=""><input type="hidden" name="phase" value="traitement" />';
		for($i=0;$i<$nb;$i++)
			$chaine .= '<input type="radio" name="choix" value="'.$skin[$i].'" '. (($choix==$skin[$i])? 'checked="checked"' : '') .' />'.$skin[$i].' <br />'; 
		$chaine .= '<br /><input type="submit" accesskey="s" value="'.THEMES_BUTTON.'" onclick="location.href=\'index.php?action=theme\';" /></form>';
		$this->content = $chaine;
	}

	function build_html()
	{	$t0 = microtime_float();	
		$theme = THEMES_DIR.$this->read( THEMES_DIR.THEMES_FILE );
		$html  = $this->read( $theme.'/template.html' );
		$html = preg_replace('/{SCREEN_STYLES}/', $theme.'/screen_styles.css', $html);
		$html = preg_replace('/{PRINT_STYLES}/', $theme.'/print_styles.css', $html);				
		$html = preg_replace('/{WIKI_TITLE}/', WIKI_TITLE, $html);
		$html = preg_replace('/{HOME}/', $this->home, $html);
		$html = preg_replace('/{PREV}/', '<a href="javascript:history.back()">retour</a>', $html);
		$html = preg_replace('/{ADMIN}/', $this->admin, $html);
		$html = preg_replace('/{SEARCH}/', $this->search, $html); // KEOPS
		$html = preg_replace('/{HELP}/', $this->help, $html);
		$html = preg_replace('/{EDIT}/', $this->edit, $html);
		// KEOPS titre page édition
		if($this->editing) {
			$html = preg_replace('/{PAGE_TITLE}/', $this->page.' > &eacute;dition', $html);
		} else {
			$html = preg_replace('/{PAGE_TITLE}/', $this->page, $html);
		}
		$html = preg_replace('/{CONTENT}/', $this->content, $html);
		$date = 'date : '.date('j\/m\/y\ H\:i');
		$IP = $_SERVER['REMOTE_ADDR'];
		$IP= 'IP : <a style="text-decoration: none;color:#000000;" href="http://www.generic-nic.net/dyn/whois/ask?query='.$IP.'" title="Infos rapides sur votre IP">'.$IP.'</a>';
		/*function getisp($ip='') {
			if ($ip=='') $ip = $_SERVER['REMOTE_ADDR'];
			$longisp = @gethostbyaddr($ip);
		    $myisp=$longisp;
			return $myisp;
		}
		$IP = getisp();*/
		$duree = 'cpu : '.round((microtime_float()-$t0)*1000).' ms';
		$html = preg_replace('/{FOOT_PAGE}/', $this->time .' | '.$date.' | '.$IP.' | <a href="http://amartyfree.free.fr/almawiki/" style="text-decoration: none; color: #000099" title="Découvrir almawiki">'.FOOT_PAGE.'</a> mod <a href="index.php?page=aide#apropos" title="Voir &agrave; propos">WikiTeP</a> | <a href="?page=RSS" title="Page sur le fil RSS">RSS</a> &nbsp;', $html); // KEOPS
		echo $html;
	}

}	// fin class wiki

$mywiki = new mywiki();		// création du wiki
$mywiki->build_html()		// création de la page html

?>