// KEOPS TeP scripts
// voir meca/script.js

// KEOPS Boutons du MenuBar d'édition

// Startup variables
var theSelection = false;

// Check for Browser & Platform for PC & IE specific bits
// More details from: http://www.mozilla.org/docs/web-developer/sniffer/browser_type.html
var clientPC = navigator.userAgent.toLowerCase(); // Get client info
var clientVer = parseInt(navigator.appVersion); // Get browser version

var is_ie = ((clientPC.indexOf("msie") != -1) && (clientPC.indexOf("opera") == -1));
var is_nav = ((clientPC.indexOf('mozilla')!=-1) && (clientPC.indexOf('spoofer')==-1)
                && (clientPC.indexOf('compatible') == -1) && (clientPC.indexOf('opera')==-1)
                && (clientPC.indexOf('webtv')==-1) && (clientPC.indexOf('hotjava')==-1));
var is_moz = 0;

var is_win = ((clientPC.indexOf("win")!=-1) || (clientPC.indexOf("16bit") != -1));
var is_mac = (clientPC.indexOf("mac")!=-1);


function tep_remplacement(champ,debut,fin,correction) {
	var txtarea = champ;

	txtarea.focus();
	donotinsert = false;
	theSelection = false;
	bblast = 0;

	if ((clientVer >= 4) && is_ie && is_win)
	{
		theSelection = document.selection.createRange().text; // Get text selection
		if (theSelection) {

			while (theSelection.substring(theSelection.length-1, theSelection.length) == ' ')
			{
				theSelection = theSelection.substring(0, theSelection.length-1);
				fin = fin + " ";
			}
			if (theSelection.substring(0,1) == '{' && debut.substring(0,1) == '{')
			{
				debut = debut + " ";
			}
			if (theSelection.substring(theSelection.length-1, theSelection.length) == '}' && fin.substring(0,1) == '}')
			{
				fin = " " + fin;
			}

			// Add tags around selection
			document.selection.createRange().text = debut + theSelection + fin;
			txtarea.focus();
			theSelection = '';
			return;
		}
	}
	else if (txtarea.selectionEnd) //&& (txtarea.selectionEnd - txtarea.selectionStart > 0))
	{
		mozWrap(txtarea, debut, fin, correction);
		return;
	}
}

function setSelectionRange(input, selectionStart, selectionEnd) {
  if (input.setSelectionRange) {
    input.focus();
    input.setSelectionRange(selectionStart, selectionEnd);
  }
  else if (input.createTextRange) {
    var range = input.createTextRange();
    range.collapse(true);
    range.moveEnd('character', selectionEnd);
    range.moveStart('character', selectionStart);
    range.select();
  }
}


function mozWrap(txtarea, open, close, correction)
{
	var selLength = txtarea.textLength;
	var selStart = txtarea.selectionStart;
	var selEnd = txtarea.selectionEnd;
	if (selEnd == 1 || selEnd == 2)
		selEnd = selLength;
	var selTop = txtarea.scrollTop;

	// Raccourci la selection par double-clic si dernier caractere est espace	
	if (selEnd - selStart > 0 && (txtarea.value).substring(selEnd-1,selEnd) == ' ') selEnd = selEnd-1;
	
	var s1 = (txtarea.value).substring(0,selStart);
	var s2 = (txtarea.value).substring(selStart, selEnd)
	var s3 = (txtarea.value).substring(selEnd, selLength);

	txtarea.value = s1 + open + s2 + close + s3;
	selDeb = selStart + open.length;
	selFin = selEnd + close.length-1+correction;
	window.setSelectionRange(txtarea, selDeb, selFin);
	txtarea.scrollTop = selTop;
	txtarea.focus();
	
	return;
}

function tep_btn_teppopup() {
	//affiche une fenêtre avec TeP
	window.open("flash/index.php","TracenPoche");
}
function tep_btn_italic() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"<i>","</i>",0);
}
function tep_btn_bold() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"<b>","</b>",0);
}
function tep_btn_underline() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"<u>","</u>",0);
}
function tep_btn_p() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"<p>","</p>",0);
}
function tep_btn_liste() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"<ul>","</ul>",0);
}
function tep_btn_element() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"<li>","</li>",0);
}
function tep_btn_carspepopup() {
	//affiche une fenêtre avec TeP
		window.open("http://www.alanwood.net/demos/ent4_frame.html","CarSpe");
}
function tep_btn_lien() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"[[","]]",1);
}
function tep_btn_page() {
	var r = prompt( "page :","" );
	if(r!="") {
		tep_remplacement(document.getElementById( 'editeur' ).content,"[[","|?page="+r+"]]",1);
	} else {
		tep_remplacement(document.getElementById( 'editeur' ).content,"[[","]]",1);
	}
}
function tep_btn_url() {
	var r = prompt( "url :","" );
	if(r!="") {
		tep_remplacement(document.getElementById( 'editeur' ).content,"[[","|"+r+"]]",1);
	} else {
		tep_remplacement(document.getElementById( 'editeur' ).content,"[[","]]",1);
	}
}
function tep_btn_br() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"<br />","",7);
}
function tep_btn_balisetep() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"<tep>","</tep>",0);
}
function tep_btn_balisetepweb() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"<tepweb>","</tepweb>",0);
}
function tep_btn_balisetepscript() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"<tepscript>","</tepscript>",0);
}
function tep_btn_balisetepwebscript() {
	tep_remplacement(document.getElementById( 'editeur' ).content,"<tepwebscript>","</tepwebscript>",0);
}
